Revit Solid相交过滤器使用

这段代码展示了如何在Revit API中通过包围盒过滤器获取与给定固体相交的结构框架元素。首先,它计算固体的边界框并转换到世界坐标系,然后创建一个Outline对象和BoundingBoxIntersectsFilter。接着,使用FilteredElementCollector筛选出与Outline相交且类别为OST_StructuralFraming的元素。
摘要由CSDN通过智能技术生成

1.通过solid信息构建相交过滤器过滤图元

public List<Element> GetIntersectsElements(Solid solid, Document doc)
        {
            //solid的boundingbox是局部坐标矩阵转换为世界坐标系
            Transform transform = solid.GetBoundingBox().Transform;
            XYZ minSolid = solid.GetBoundingBox().Min;
            XYZ maxSolid = solid.GetBoundingBox().Max;

            XYZ acturalMin = transform.OfPoint(minSolid);
            XYZ acturalMax = transform.OfPoint(maxSolid);

            Outline outline = new Outline(acturalMin, acturalMax);

            BoundingBoxIntersectsFilter boxFilter = new BoundingBoxIntersectsFilter(outline);

            FilteredElementCollector collector = new FilteredElementCollector(doc);
            List<Element> intersectElements = collector.WherePasses(boxFilter).Where(s => s.GetCategory().Equals(BuiltInCategory.OST_StructuralFraming)).ToList();
            return intersectElements;
        }

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值